CREATE TYPE "status_rekening" AS ENUM (
  'Aktif',
  'Nonaktif'
);

CREATE TYPE "kategori_pembayaran" AS ENUM (
  'Tunai',
  'Debit',
  'Dompet Digital',
  'Kartu Kredit'
);

CREATE TYPE "kategori_pengeluaran" AS ENUM (
  'Makanan',
  'Transportasi',
  'Dompet Digital',
  'Kebutuhan Bulanan',
  'Belanja',
  'Sewa/Kontrak',
  'Cicilan',
  'Entertainment',
  'Hobi',
  'Olahraga',
  'Kesehatan',
  'Pendidikan',
  'Asuransi',
  'Investasi',
  'Amal/Donasi',
  'Uang Keluar'
);

CREATE TYPE "kategori_pemasukan" AS ENUM (
  'Gaji',
  'Usaha',
  'Bonus',
  'Bunga',
  'Hadiah',
  'Uang Masuk'
);

CREATE TYPE "status_transaksi" AS ENUM (
  'Sukses',
  'Gagal'
);

CREATE TABLE "jenis_tabungan" (
  "id" INT GENERATED BY DEFAULT AS IDENTITY PRIMARY KEY,
  "nama_jenis" varchar,
  "setoran_awal" int,
  "saldo_minimum" int,
  "biaya_bulanan" int
);

CREATE TABLE "rekening" (
  "id" INT GENERATED BY DEFAULT AS IDENTITY PRIMARY KEY,
  "id_jenis_tabungan" int,
  "nomor_rekening" varchar UNIQUE,
  "nomor_kartu" varchar UNIQUE,
  "nama_rekening" varchar,
  "status" status_rekening,
  "saldo" int,
  "id_akun" int
);

CREATE TABLE "mutasi" (
  "id" INT GENERATED BY DEFAULT AS IDENTITY PRIMARY KEY,
  "keterangan" varchar,
  "nominal" int,
  "tanggal" date,
  "waktu" time,
  "id_rekening" int
);

CREATE TABLE "akun" (
  "id" INT GENERATED BY DEFAULT AS IDENTITY PRIMARY KEY,
  "nama_pengguna" varchar,
  "nomor_telepon" varchar UNIQUE,
  "alamat_email" varchar UNIQUE,
  "username" varchar UNIQUE,
  "katasandi" varchar,
  "nomor_pin" varchar,
  "tgl_bergabung" date
);

CREATE TABLE "notifikasi" (
  "id" INT GENERATED BY DEFAULT AS IDENTITY PRIMARY KEY,
  "gambar" varchar,
  "judul" varchar,
  "isi" text,
  "tanggal" date,
  "waktu" time
);

CREATE TABLE "akun_notifikasi" (
  "id_akun" int,
  "id_notifikasi" int,
  PRIMARY KEY ("id_akun", "id_notifikasi")
);

CREATE TABLE "promo" (
  "id" INT GENERATED BY DEFAULT AS IDENTITY PRIMARY KEY,
  "gambar" varchar,
  "judul" varchar,
  "isi" text
);

CREATE TABLE "akun_promo" (
  "id_akun" int,
  "id_promo" int,
  PRIMARY KEY ("id_akun", "id_promo")
);

CREATE TABLE "catatan_keuangan" (
  "id" INT GENERATED BY DEFAULT AS IDENTITY PRIMARY KEY,
  "pengeluaran" kategori_pengeluaran,
  "pemasukan" kategori_pemasukan,
  "nominal" int,
  "tanggal" date,
  "waktu" time,
  "pembayaran" kategori_pembayaran,
  "keterangan" varchar,
  "id_rekening" int,
  "id_akun" int
);

CREATE TABLE "transaksi" (
  "id" INT GENERATED BY DEFAULT AS IDENTITY PRIMARY KEY,
  "tanggal" date,
  "waktu" time,
  "id_sumber_dana" int,
  "jenis_transaksi" varchar,
  "nomor_tujuan" varchar,
  "nominal" int,
  "biaya_admin" int,
  "total" int,
  "status" status_transaksi
);

CREATE TABLE "detail_transaksi" (
  "id" int PRIMARY KEY,
  "institusi" varchar,
  "nama_tujuan" varchar,
  "alias_penerima" varchar,
  "keterangan" varchar,
  "catatan" text,
  "jenis_produk" varchar
);

CREATE TABLE "aktivitas" (
  "id" INT GENERATED BY DEFAULT AS IDENTITY PRIMARY KEY,
  "id_akun" int,
  "kategori_layanan" varchar,
  "id_transaksi" int
);

ALTER TABLE "rekening" ADD FOREIGN KEY ("id_jenis_tabungan") REFERENCES "jenis_tabungan" ("id");

ALTER TABLE "rekening" ADD FOREIGN KEY ("id_akun") REFERENCES "akun" ("id");

ALTER TABLE "mutasi" ADD FOREIGN KEY ("id_rekening") REFERENCES "rekening" ("id");

ALTER TABLE "akun_notifikasi" ADD FOREIGN KEY ("id_akun") REFERENCES "akun" ("id");

ALTER TABLE "akun_notifikasi" ADD FOREIGN KEY ("id_notifikasi") REFERENCES "notifikasi" ("id");

ALTER TABLE "akun_promo" ADD FOREIGN KEY ("id_akun") REFERENCES "akun" ("id");

ALTER TABLE "akun_promo" ADD FOREIGN KEY ("id_promo") REFERENCES "promo" ("id");

ALTER TABLE "catatan_keuangan" ADD FOREIGN KEY ("id_rekening") REFERENCES "rekening" ("id");

ALTER TABLE "catatan_keuangan" ADD FOREIGN KEY ("id_akun") REFERENCES "akun" ("id");

ALTER TABLE "transaksi" ADD FOREIGN KEY ("id_sumber_dana") REFERENCES "rekening" ("id");

ALTER TABLE "detail_transaksi" ADD FOREIGN KEY ("id") REFERENCES "transaksi" ("id");

ALTER TABLE "aktivitas" ADD FOREIGN KEY ("id_akun") REFERENCES "akun" ("id");

ALTER TABLE "aktivitas" ADD FOREIGN KEY ("id_transaksi") REFERENCES "transaksi" ("id");